/*
 * Copyright (C) 2015 Jared Boone, ShareBrained Technology, Inc.
 * Copyright (C) 2016 Furrtek
 *
 * This file is part of PortaPack.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

#include "ui_textentry.hpp"

namespace ui {

bool textentry(NavigationView& nav, char * str, uint16_t max_length) {
	if (portapack::persistent_memory::ui_config_textentry() == 0) {
		auto an_view = nav.push<AlphanumView>(str, max_length);
		an_view->on_changed = [str, max_length](char * value) {
			memcpy(str, value, max_length + 1);
		};
	} else {
		auto an_view = nav.push<HandWriteView>(str, max_length);
		an_view->on_changed = [str, max_length](char * value) {
			memcpy(str, value, max_length + 1);
		};
	}
	
	return true;
}

} /* namespace ui */
